"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeOfChange = void 0;
// cspell:ignore bboxes
/** Bitflags describing which aspects of an [Element]($backend) changed as part of a [[ChangedElements]].
 * @public
 */
var TypeOfChange;
(function (TypeOfChange) {
    /** A property in the element changed */
    TypeOfChange[TypeOfChange["Property"] = 1] = "Property";
    /** The geometry stream of a [GeometricElement]($backend) changed */
    TypeOfChange[TypeOfChange["Geometry"] = 2] = "Geometry";
    /** The [[Placement]] of a [GeometricElement]($backend) changed */
    TypeOfChange[TypeOfChange["Placement"] = 4] = "Placement";
    /** Indirect change occurred to this element by a related instance */
    TypeOfChange[TypeOfChange["Indirect"] = 8] = "Indirect";
    /** Hidden properties of the element changed */
    TypeOfChange[TypeOfChange["Hidden"] = 16] = "Hidden";
})(TypeOfChange = exports.TypeOfChange || (exports.TypeOfChange = {}));
//# sourceMappingURL=ChangedElements.js.map