/** @packageDocumentation
 * @module CloudStorage
 */
import { CloudStorageCache, CloudStorageContainerDescriptor, CloudStorageContainerUrl } from "./CloudStorage";
import { IModelRpcProps } from "./IModel";
/** @beta */
export interface TileContentIdentifier {
    tokenProps: IModelRpcProps;
    treeId: string;
    contentId: string;
    guid: string | undefined;
}
/** @beta */
export declare class CloudStorageTileCache extends CloudStorageCache<TileContentIdentifier, Uint8Array> {
    private static _instance;
    static getCache(): CloudStorageTileCache;
    supplyExpiryForContainerUrl(_id: CloudStorageContainerDescriptor): Date;
    protected constructor();
    protected obtainContainerUrl(id: TileContentIdentifier, descriptor: CloudStorageContainerDescriptor): Promise<CloudStorageContainerUrl>;
    protected instantiateResource(response: Response): Promise<Uint8Array | undefined>;
    formContainerName(id: TileContentIdentifier): string;
    formResourceName(id: TileContentIdentifier): string;
    protected formContainerKey(id: TileContentIdentifier): string;
}
//# sourceMappingURL=CloudStorageTileCache.d.ts.map