/** @packageDocumentation
 * @module Symbology
 */
/** A set of known colors by [HTML color name](https://developer.mozilla.org/en-US/docs/Web/CSS/color_value), as a 32-bit integer in the form 0xBBGGRR (red is the low byte).
 * This is different than color values in #RRGGBB format for HTML pages (red and blue are swapped).
 * @note If your colors don't look right, likely you're using 0xRRGGBB where ColorDef expects 0xBBGGRR.
 * @public
 */
export declare const ColorByName: {
    aliceBlue: number;
    amber: number;
    antiqueWhite: number;
    aqua: number;
    aquamarine: number;
    azure: number;
    beige: number;
    bisque: number;
    black: number;
    blanchedAlmond: number;
    blue: number;
    blueViolet: number;
    brown: number;
    burlyWood: number;
    cadetBlue: number;
    chartreuse: number;
    chocolate: number;
    coral: number;
    cornflowerBlue: number;
    cornSilk: number;
    crimson: number;
    cyan: number;
    darkBlue: number;
    darkBrown: number;
    darkCyan: number;
    darkGoldenrod: number;
    darkGray: number;
    darkGreen: number;
    darkGrey: number;
    darkKhaki: number;
    darkMagenta: number;
    darkOliveGreen: number;
    darkOrange: number;
    darkOrchid: number;
    darkRed: number;
    darkSalmon: number;
    darkSeagreen: number;
    darkSlateBlue: number;
    darkSlateGray: number;
    darkSlateGrey: number;
    darkTurquoise: number;
    darkViolet: number;
    deepPink: number;
    deepSkyBlue: number;
    dimGray: number;
    dimGrey: number;
    dodgerBlue: number;
    fireBrick: number;
    floralWhite: number;
    forestGreen: number;
    fuchsia: number;
    gainsboro: number;
    ghostWhite: number;
    gold: number;
    goldenrod: number;
    gray: number;
    green: number;
    greenYellow: number;
    grey: number;
    honeydew: number;
    hotPink: number;
    indianRed: number;
    indigo: number;
    ivory: number;
    khaki: number;
    lavender: number;
    lavenderBlush: number;
    lawnGreen: number;
    lemonChiffon: number;
    lightBlue: number;
    lightCoral: number;
    lightCyan: number;
    lightGoldenrodYellow: number;
    lightGray: number;
    lightGreen: number;
    lightGrey: number;
    lightPink: number;
    lightSalmon: number;
    lightSeagreen: number;
    lightSkyBlue: number;
    lightSlateGray: number;
    lightSlateGrey: number;
    lightSteelBlue: number;
    lightyellow: number;
    lime: number;
    limeGreen: number;
    linen: number;
    magenta: number;
    maroon: number;
    mediumAquamarine: number;
    mediumBlue: number;
    mediumOrchid: number;
    mediumPurple: number;
    mediumSeaGreen: number;
    mediumSlateBlue: number;
    mediumSpringGreen: number;
    mediumTurquoise: number;
    mediumVioletRed: number;
    midnightBlue: number;
    mintCream: number;
    mistyRose: number;
    moccasin: number;
    navajoWhite: number;
    navy: number;
    oldLace: number;
    olive: number;
    oliveDrab: number;
    orange: number;
    orangeRed: number;
    orchid: number;
    paleGoldenrod: number;
    paleGreen: number;
    paleTurquoise: number;
    paleVioletRed: number;
    papayaWhip: number;
    peachPuff: number;
    peru: number;
    pink: number;
    plum: number;
    powderBlue: number;
    purple: number;
    rebeccaPurple: number;
    red: number;
    rosyBrown: number;
    royalBlue: number;
    saddleBrown: number;
    salmon: number;
    sandyBrown: number;
    seaGreen: number;
    seaShell: number;
    sienna: number;
    silver: number;
    skyBlue: number;
    slateBlue: number;
    slateGray: number;
    slateGrey: number;
    snow: number;
    springGreen: number;
    steelBlue: number;
    tan: number;
    teal: number;
    thistle: number;
    tomato: number;
    turquoise: number;
    violet: number;
    wheat: number;
    white: number;
    whiteSmoke: number;
    yellow: number;
    yellowGreen: number;
};
//# sourceMappingURL=ColorByName.d.ts.map