/** @packageDocumentation
 * @module Logging
 */
/** Logger categories used by this package
 * @see [Logger]($bentley)
 * @public
 */
export declare enum CommonLoggerCategory {
    /** The logger category used by common classes relating to ElementProps. */
    ElementProps = "imodeljs-common.ElementProps",
    /** The logger category used by common classes relating to Geometry. */
    Geometry = "imodeljs-common.Geometry",
    /** The logger category used by the portions of the RpcInterface framework that run on the backend. */
    RpcInterfaceBackend = "imodeljs-backend.RpcInterface",
    /** The logger category used by the portions of the RpcInterface framework that run on the frontend. */
    RpcInterfaceFrontend = "imodeljs-frontend.RpcInterface"
}
//# sourceMappingURL=CommonLoggerCategory.d.ts.map