"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Logging
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonLoggerCategory = void 0;
/** Logger categories used by this package
 * @see [Logger]($bentley)
 * @public
 */
var CommonLoggerCategory;
(function (CommonLoggerCategory) {
    /** The logger category used by common classes relating to ElementProps. */
    CommonLoggerCategory["ElementProps"] = "imodeljs-common.ElementProps";
    /** The logger category used by common classes relating to Geometry. */
    CommonLoggerCategory["Geometry"] = "imodeljs-common.Geometry";
    /** The logger category used by the portions of the RpcInterface framework that run on the backend. */
    CommonLoggerCategory["RpcInterfaceBackend"] = "imodeljs-backend.RpcInterface";
    /** The logger category used by the portions of the RpcInterface framework that run on the frontend. */
    CommonLoggerCategory["RpcInterfaceFrontend"] = "imodeljs-frontend.RpcInterface";
})(CommonLoggerCategory = exports.CommonLoggerCategory || (exports.CommonLoggerCategory = {}));
//# sourceMappingURL=CommonLoggerCategory.js.map