"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Rendering
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureOverrideType = void 0;
/** Options for overriding element appearance.
 * @see [EmphasizeElements]($frontend)
 * @see [[AppearanceOverrideProps]]
 * @public
 */
var FeatureOverrideType;
(function (FeatureOverrideType) {
    /** Override color only. */
    FeatureOverrideType[FeatureOverrideType["ColorOnly"] = 0] = "ColorOnly";
    /** Override alpha only. */
    FeatureOverrideType[FeatureOverrideType["AlphaOnly"] = 1] = "AlphaOnly";
    /** Override both color and alpha. */
    FeatureOverrideType[FeatureOverrideType["ColorAndAlpha"] = 2] = "ColorAndAlpha";
})(FeatureOverrideType = exports.FeatureOverrideType || (exports.FeatureOverrideType = {}));
//# sourceMappingURL=EmphasizeElementsProps.js.map