/** @packageDocumentation
 * @module Rendering
 */
import { ColorDef } from "./ColorDef";
/** @internal */
export declare class NonUniformColor {
    readonly colors: Uint32Array;
    readonly indices: Uint16Array;
    readonly isOpaque: boolean;
    constructor(colors: Uint32Array, indices: number[], hasAlpha: boolean);
}
/** @internal */
export declare class ColorIndex {
    private _color;
    get hasAlpha(): boolean;
    get isUniform(): boolean;
    get numColors(): number;
    constructor();
    reset(): void;
    get uniform(): ColorDef | undefined;
    initUniform(color: ColorDef | number): void;
    get nonUniform(): NonUniformColor | undefined;
    initNonUniform(colors: Uint32Array, indices: number[], hasAlpha: boolean): void;
}
/** @internal */
export declare enum FeatureIndexType {
    Empty = 0,
    Uniform = 1,
    NonUniform = 2
}
/** @internal */
export declare class FeatureIndex {
    type: FeatureIndexType;
    featureID: number;
    featureIDs?: Uint32Array;
    constructor();
    get isUniform(): boolean;
    get isEmpty(): boolean;
    reset(): void;
}
//# sourceMappingURL=FeatureIndex.d.ts.map