/** @packageDocumentation
 * @module Geometry
 */
import { BentleyStatus, Id64Array } from "@bentley/bentleyjs-core";
import { ViewFlagProps } from "./ViewFlags";
import { ClipPlaneContainment } from "@bentley/geometry-core";
/** Information required to request clip containment status for elements from the front end to the back end.
 * @public
 */
export interface GeometryContainmentRequestProps {
    candidates: Id64Array;
    clip: any;
    allowOverlaps?: boolean;
    viewFlags?: ViewFlagProps;
    offSubCategories?: Id64Array;
}
/** Information returned from the back end to the front end holding the result of the geometry containment query.
 * @public
 */
export interface GeometryContainmentResponseProps {
    status: BentleyStatus;
    candidatesContainment?: ClipPlaneContainment[];
    numInside?: number;
    numOutside?: number;
    numOverlap?: number;
}
//# sourceMappingURL=GeometryContainment.d.ts.map