"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Geometry
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeometrySummaryVerbosity = void 0;
/** Describes the level of detail with which to report each geometric primitive in a [[GeometrySummaryRequestProps]].
 * @public
 */
var GeometrySummaryVerbosity;
(function (GeometrySummaryVerbosity) {
    /** Simply output the type of geometry as a string. */
    GeometrySummaryVerbosity[GeometrySummaryVerbosity["Basic"] = 10] = "Basic";
    /** Output some details of the geometry. e.g., for a sphere, include the center and radius; for a line string, the number of points; etc. */
    GeometrySummaryVerbosity[GeometrySummaryVerbosity["Detailed"] = 20] = "Detailed";
    /** Output extremely detailed information. e.g., for a line string, the coordinates of each point. This may produce an enormous amount of data for some primitives. */
    GeometrySummaryVerbosity[GeometrySummaryVerbosity["Full"] = 30] = "Full";
})(GeometrySummaryVerbosity = exports.GeometrySummaryVerbosity || (exports.GeometrySummaryVerbosity = {}));
//# sourceMappingURL=GeometrySummary.js.map