"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Geometry
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MassPropertiesOperation = void 0;
/** Specify whether to accumulate volumes, areas, or lengths for the supplied elements.
 * @public
 */
var MassPropertiesOperation;
(function (MassPropertiesOperation) {
    /** Return lengths for open paths and planar regions. */
    MassPropertiesOperation[MassPropertiesOperation["AccumulateLengths"] = 0] = "AccumulateLengths";
    /** Return areas and perimeters for solid and surface geometry. */
    MassPropertiesOperation[MassPropertiesOperation["AccumulateAreas"] = 1] = "AccumulateAreas";
    /** Return volumes and areas for solid geometry. */
    MassPropertiesOperation[MassPropertiesOperation["AccumulateVolumes"] = 2] = "AccumulateVolumes";
})(MassPropertiesOperation = exports.MassPropertiesOperation || (exports.MassPropertiesOperation = {}));
//# sourceMappingURL=MassProperties.js.map