"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Rendering
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextureMapUnits = void 0;
/** Describes the units in which a [[TextureMapProps]]' scale is expressed.
 * @public
 */
var TextureMapUnits;
(function (TextureMapUnits) {
    /** Indicates the scale has no units. */
    TextureMapUnits[TextureMapUnits["Relative"] = 0] = "Relative";
    TextureMapUnits[TextureMapUnits["Meters"] = 3] = "Meters";
    TextureMapUnits[TextureMapUnits["Millimeters"] = 4] = "Millimeters";
    TextureMapUnits[TextureMapUnits["Feet"] = 5] = "Feet";
    TextureMapUnits[TextureMapUnits["Inches"] = 6] = "Inches";
})(TextureMapUnits = exports.TextureMapUnits || (exports.TextureMapUnits = {}));
//# sourceMappingURL=MaterialProps.js.map