"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module NativeApp
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverriddenBy = exports.InternetConnectivityStatus = exports.nativeAppNotify = exports.nativeAppChannel = void 0;
/** @internal */
exports.nativeAppChannel = "nativeApp";
/** @internal */
exports.nativeAppNotify = "nativeApp-notify";
/** Indicates whether or not the computer is currently connected to the internet.
 * @beta
 */
var InternetConnectivityStatus;
(function (InternetConnectivityStatus) {
    InternetConnectivityStatus[InternetConnectivityStatus["Online"] = 0] = "Online";
    InternetConnectivityStatus[InternetConnectivityStatus["Offline"] = 1] = "Offline";
})(InternetConnectivityStatus = exports.InternetConnectivityStatus || (exports.InternetConnectivityStatus = {}));
/** Describes whether the user or the browser overrode the internet connectivity status.
 * @beta
 */
var OverriddenBy;
(function (OverriddenBy) {
    OverriddenBy[OverriddenBy["Browser"] = 0] = "Browser";
    OverriddenBy[OverriddenBy["User"] = 1] = "User";
})(OverriddenBy = exports.OverriddenBy || (exports.OverriddenBy = {}));
//# sourceMappingURL=NativeAppProps.js.map