"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module DisplayStyles
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SkyBoxImageType = void 0;
/** Enumerates the supported types of [SkyBox]($frontend) images.
 * @public
 */
var SkyBoxImageType;
(function (SkyBoxImageType) {
    SkyBoxImageType[SkyBoxImageType["None"] = 0] = "None";
    /** A single image mapped to the surface of a sphere. @see [SkySphere]($frontend) */
    SkyBoxImageType[SkyBoxImageType["Spherical"] = 1] = "Spherical";
    /** @internal not yet supported */
    SkyBoxImageType[SkyBoxImageType["Cylindrical"] = 2] = "Cylindrical";
    /** 6 images mapped to the faces of a cube. @see [SkyCube]($frontend) */
    SkyBoxImageType[SkyBoxImageType["Cube"] = 3] = "Cube";
})(SkyBoxImageType = exports.SkyBoxImageType || (exports.SkyBoxImageType = {}));
//# sourceMappingURL=SkyBox.js.map