"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EGFBAccessors = void 0;
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Serialization
 */
const flatbuffers_1 = require("flatbuffers");
/* eslint-disable @typescript-eslint/naming-convention */
/* eslint-disable @typescript-eslint/explicit-member-accessibility */
/* eslint-disable @bentley/prefer-get */
/* eslint-disable no-var */
// cspell:word flatbuffers
var EGFBAccessors;
(function (EGFBAccessors) {
    // automatically generated by the FlatBuffers compiler, do not modify
    /**
     * @enum {number}
     */
    let GradientMode;
    (function (GradientMode) {
        GradientMode[GradientMode["None"] = 0] = "None";
        GradientMode[GradientMode["Linear"] = 1] = "Linear";
        GradientMode[GradientMode["Curved"] = 2] = "Curved";
        GradientMode[GradientMode["Cylindrical"] = 3] = "Cylindrical";
        GradientMode[GradientMode["Spherical"] = 4] = "Spherical";
        GradientMode[GradientMode["Hemispherical"] = 5] = "Hemispherical";
        GradientMode[GradientMode["Thematic"] = 6] = "Thematic";
    })(GradientMode = EGFBAccessors.GradientMode || (EGFBAccessors.GradientMode = {}));
    /**
     * @enum {number}
     */
    let BoundaryType;
    (function (BoundaryType) {
        BoundaryType[BoundaryType["None"] = 0] = "None";
        BoundaryType[BoundaryType["Open"] = 1] = "Open";
        BoundaryType[BoundaryType["Closed"] = 2] = "Closed";
    })(BoundaryType = EGFBAccessors.BoundaryType || (EGFBAccessors.BoundaryType = {}));
    /**
     * @enum {number}
     */
    let FillDisplay;
    (function (FillDisplay) {
        FillDisplay[FillDisplay["None"] = 0] = "None";
        FillDisplay[FillDisplay["ByView"] = 1] = "ByView";
        FillDisplay[FillDisplay["Always"] = 2] = "Always";
        FillDisplay[FillDisplay["Blanking"] = 3] = "Blanking";
    })(FillDisplay = EGFBAccessors.FillDisplay || (EGFBAccessors.FillDisplay = {}));
    /**
     * @enum {number}
     */
    let GeometryClass;
    (function (GeometryClass) {
        GeometryClass[GeometryClass["Primary"] = 0] = "Primary";
        GeometryClass[GeometryClass["Construction"] = 1] = "Construction";
        GeometryClass[GeometryClass["Dimension"] = 2] = "Dimension";
        GeometryClass[GeometryClass["Pattern"] = 3] = "Pattern";
    })(GeometryClass = EGFBAccessors.GeometryClass || (EGFBAccessors.GeometryClass = {}));
    /**
     * @enum {number}
     */
    let BRepType;
    (function (BRepType) {
        BRepType[BRepType["Solid"] = 0] = "Solid";
        BRepType[BRepType["Sheet"] = 1] = "Sheet";
        BRepType[BRepType["Wire"] = 2] = "Wire";
    })(BRepType = EGFBAccessors.BRepType || (EGFBAccessors.BRepType = {}));
    /**
     * @constructor
     */
    class DPoint3d {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns DPoint3d
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        y() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        z() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x
         * @param number y
         * @param number z
         * @returns flatbuffers.Offset
         */
        static createDPoint3d(builder, x, y, z) {
            builder.prep(8, 24);
            builder.writeFloat64(z);
            builder.writeFloat64(y);
            builder.writeFloat64(x);
            return builder.offset();
        }
    }
    EGFBAccessors.DPoint3d = DPoint3d;
    /**
     * @constructor
     */
    class DPoint2d {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns DPoint2d
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        y() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x
         * @param number y
         * @returns flatbuffers.Offset
         */
        static createDPoint2d(builder, x, y) {
            builder.prep(8, 16);
            builder.writeFloat64(y);
            builder.writeFloat64(x);
            return builder.offset();
        }
    }
    EGFBAccessors.DPoint2d = DPoint2d;
    /**
     * @constructor
     */
    class DVec3d {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns DVec3d
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        y() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        z() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x
         * @param number y
         * @param number z
         * @returns flatbuffers.Offset
         */
        static createDVec3d(builder, x, y, z) {
            builder.prep(8, 24);
            builder.writeFloat64(z);
            builder.writeFloat64(y);
            builder.writeFloat64(x);
            return builder.offset();
        }
    }
    EGFBAccessors.DVec3d = DVec3d;
    /**
     * @constructor
     */
    class RotMatrix {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns RotMatrix
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x00() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        x01() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        x02() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @returns number
         */
        x10() {
            return this.bb.readFloat64(this.bb_pos + 24);
        }
        /**
         * @returns number
         */
        x11() {
            return this.bb.readFloat64(this.bb_pos + 32);
        }
        /**
         * @returns number
         */
        x12() {
            return this.bb.readFloat64(this.bb_pos + 40);
        }
        /**
         * @returns number
         */
        x20() {
            return this.bb.readFloat64(this.bb_pos + 48);
        }
        /**
         * @returns number
         */
        x21() {
            return this.bb.readFloat64(this.bb_pos + 56);
        }
        /**
         * @returns number
         */
        x22() {
            return this.bb.readFloat64(this.bb_pos + 64);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x00
         * @param number x01
         * @param number x02
         * @param number x10
         * @param number x11
         * @param number x12
         * @param number x20
         * @param number x21
         * @param number x22
         * @returns flatbuffers.Offset
         */
        static createRotMatrix(builder, x00, x01, x02, x10, x11, x12, x20, x21, x22) {
            builder.prep(8, 72);
            builder.writeFloat64(x22);
            builder.writeFloat64(x21);
            builder.writeFloat64(x20);
            builder.writeFloat64(x12);
            builder.writeFloat64(x11);
            builder.writeFloat64(x10);
            builder.writeFloat64(x02);
            builder.writeFloat64(x01);
            builder.writeFloat64(x00);
            return builder.offset();
        }
    }
    EGFBAccessors.RotMatrix = RotMatrix;
    /**
     * @constructor
     */
    class Transform {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns Transform
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x00() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        x01() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        x02() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @returns number
         */
        tx() {
            return this.bb.readFloat64(this.bb_pos + 24);
        }
        /**
         * @returns number
         */
        x10() {
            return this.bb.readFloat64(this.bb_pos + 32);
        }
        /**
         * @returns number
         */
        x11() {
            return this.bb.readFloat64(this.bb_pos + 40);
        }
        /**
         * @returns number
         */
        x12() {
            return this.bb.readFloat64(this.bb_pos + 48);
        }
        /**
         * @returns number
         */
        ty() {
            return this.bb.readFloat64(this.bb_pos + 56);
        }
        /**
         * @returns number
         */
        x20() {
            return this.bb.readFloat64(this.bb_pos + 64);
        }
        /**
         * @returns number
         */
        x21() {
            return this.bb.readFloat64(this.bb_pos + 72);
        }
        /**
         * @returns number
         */
        x22() {
            return this.bb.readFloat64(this.bb_pos + 80);
        }
        /**
         * @returns number
         */
        tz() {
            return this.bb.readFloat64(this.bb_pos + 88);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x00
         * @param number x01
         * @param number x02
         * @param number tx
         * @param number x10
         * @param number x11
         * @param number x12
         * @param number ty
         * @param number x20
         * @param number x21
         * @param number x22
         * @param number tz
         * @returns flatbuffers.Offset
         */
        static createTransform(builder, x00, x01, x02, tx, x10, x11, x12, ty, x20, x21, x22, tz) {
            builder.prep(8, 96);
            builder.writeFloat64(tz);
            builder.writeFloat64(x22);
            builder.writeFloat64(x21);
            builder.writeFloat64(x20);
            builder.writeFloat64(ty);
            builder.writeFloat64(x12);
            builder.writeFloat64(x11);
            builder.writeFloat64(x10);
            builder.writeFloat64(tx);
            builder.writeFloat64(x02);
            builder.writeFloat64(x01);
            builder.writeFloat64(x00);
            return builder.offset();
        }
    }
    EGFBAccessors.Transform = Transform;
    /**
     * @constructor
     */
    class Trans2x3 {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns Trans2x3
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x00() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        x01() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        tx() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @returns number
         */
        y00() {
            return this.bb.readFloat64(this.bb_pos + 24);
        }
        /**
         * @returns number
         */
        y01() {
            return this.bb.readFloat64(this.bb_pos + 32);
        }
        /**
         * @returns number
         */
        ty() {
            return this.bb.readFloat64(this.bb_pos + 40);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x00
         * @param number x01
         * @param number tx
         * @param number y00
         * @param number y01
         * @param number ty
         * @returns flatbuffers.Offset
         */
        static createTrans2x3(builder, x00, x01, tx, y00, y01, ty) {
            builder.prep(8, 48);
            builder.writeFloat64(ty);
            builder.writeFloat64(y01);
            builder.writeFloat64(y00);
            builder.writeFloat64(tx);
            builder.writeFloat64(x01);
            builder.writeFloat64(x00);
            return builder.offset();
        }
    }
    EGFBAccessors.Trans2x3 = Trans2x3;
    /**
     * @constructor
     */
    class FaceSymbology {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns FaceSymbology
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        useColor() {
            return this.bb.readUint8(this.bb_pos);
        }
        /**
         * @returns number
         */
        useMaterial() {
            return this.bb.readUint8(this.bb_pos + 1);
        }
        /**
         * @returns number
         */
        color() {
            return this.bb.readUint32(this.bb_pos + 4);
        }
        /**
         * @returns flatbuffers.Long
         */
        materialId() {
            return this.bb.readInt64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        transparency() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @param DPoint2d= obj
         * @returns DPoint2d|null
         */
        uv(obj) {
            return (obj || new DPoint2d()).__init(this.bb_pos + 24, this.bb);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useColor
         * @param number useMaterial
         * @param number color
         * @param flatbuffers.Long materialId
         * @param number transparency
         * @param number uv_x
         * @param number uv_y
         * @returns flatbuffers.Offset
         */
        static createFaceSymbology(builder, useColor, useMaterial, color, materialId, transparency, uv_x, uv_y) {
            builder.prep(8, 40);
            builder.prep(8, 16);
            builder.writeFloat64(uv_y);
            builder.writeFloat64(uv_x);
            builder.writeFloat64(transparency);
            builder.writeInt64(materialId);
            builder.writeInt32(color);
            builder.pad(2);
            builder.writeInt8(useMaterial);
            builder.writeInt8(useColor);
            return builder.offset();
        }
    }
    EGFBAccessors.FaceSymbology = FaceSymbology;
    /**
     * @constructor
     */
    class FaceSymbologyIndex {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns FaceSymbologyIndex
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        faceIndex() {
            return this.bb.readUint32(this.bb_pos);
        }
        /**
         * @returns number
         */
        symbIndex() {
            return this.bb.readUint32(this.bb_pos + 4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number faceIndex
         * @param number symbIndex
         * @returns flatbuffers.Offset
         */
        static createFaceSymbologyIndex(builder, faceIndex, symbIndex) {
            builder.prep(4, 8);
            builder.writeInt32(symbIndex);
            builder.writeInt32(faceIndex);
            return builder.offset();
        }
    }
    EGFBAccessors.FaceSymbologyIndex = FaceSymbologyIndex;
    /**
     * @constructor
     */
    class DRange1d {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns DRange1d
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        low() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        high() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number low
         * @param number high
         * @returns flatbuffers.Offset
         */
        static createDRange1d(builder, low, high) {
            builder.prep(8, 16);
            builder.writeFloat64(high);
            builder.writeFloat64(low);
            return builder.offset();
        }
    }
    EGFBAccessors.DRange1d = DRange1d;
    /**
     * @constructor
     */
    class PointPrimitive {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns PointPrimitive
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param PointPrimitive= obj
         * @returns PointPrimitive
         */
        static getRootAsPointPrimitive(bb, obj) {
            return (obj || new PointPrimitive()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param PointPrimitive= obj
         * @returns PointPrimitive
         */
        static getSizePrefixedRootAsPointPrimitive(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new PointPrimitive()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param number index
         * @param DPoint3d= obj
         * @returns DPoint3d
         */
        coords(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? (obj || new DPoint3d()).__init(this.bb.__vector(this.bb_pos + offset) + index * 24, this.bb) : null;
        }
        /**
         * @returns number
         */
        coordsLength() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns BoundaryType
         */
        boundary() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : BoundaryType.None;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startPointPrimitive(builder) {
            builder.startObject(2);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset coordsOffset
         */
        static addCoords(builder, coordsOffset) {
            builder.addFieldOffset(0, coordsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startCoordsVector(builder, numElems) {
            builder.startVector(24, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param BoundaryType boundary
         */
        static addBoundary(builder, boundary) {
            builder.addFieldInt8(1, boundary, BoundaryType.None);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endPointPrimitive(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createPointPrimitive(builder, coordsOffset, boundary) {
            PointPrimitive.startPointPrimitive(builder);
            PointPrimitive.addCoords(builder, coordsOffset);
            PointPrimitive.addBoundary(builder, boundary);
            return PointPrimitive.endPointPrimitive(builder);
        }
    }
    EGFBAccessors.PointPrimitive = PointPrimitive;
    /**
     * @constructor
     */
    class PointPrimitive2d {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns PointPrimitive2d
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param PointPrimitive2d= obj
         * @returns PointPrimitive2d
         */
        static getRootAsPointPrimitive2d(bb, obj) {
            return (obj || new PointPrimitive2d()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param PointPrimitive2d= obj
         * @returns PointPrimitive2d
         */
        static getSizePrefixedRootAsPointPrimitive2d(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new PointPrimitive2d()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param number index
         * @param DPoint2d= obj
         * @returns DPoint2d
         */
        coords(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? (obj || new DPoint2d()).__init(this.bb.__vector(this.bb_pos + offset) + index * 16, this.bb) : null;
        }
        /**
         * @returns number
         */
        coordsLength() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns BoundaryType
         */
        boundary() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : BoundaryType.None;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startPointPrimitive2d(builder) {
            builder.startObject(2);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset coordsOffset
         */
        static addCoords(builder, coordsOffset) {
            builder.addFieldOffset(0, coordsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startCoordsVector(builder, numElems) {
            builder.startVector(16, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param BoundaryType boundary
         */
        static addBoundary(builder, boundary) {
            builder.addFieldInt8(1, boundary, BoundaryType.None);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endPointPrimitive2d(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createPointPrimitive2d(builder, coordsOffset, boundary) {
            PointPrimitive2d.startPointPrimitive2d(builder);
            PointPrimitive2d.addCoords(builder, coordsOffset);
            PointPrimitive2d.addBoundary(builder, boundary);
            return PointPrimitive2d.endPointPrimitive2d(builder);
        }
    }
    EGFBAccessors.PointPrimitive2d = PointPrimitive2d;
    /**
     * @constructor
     */
    class ArcPrimitive {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns ArcPrimitive
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param ArcPrimitive= obj
         * @returns ArcPrimitive
         */
        static getRootAsArcPrimitive(bb, obj) {
            return (obj || new ArcPrimitive()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param ArcPrimitive= obj
         * @returns ArcPrimitive
         */
        static getSizePrefixedRootAsArcPrimitive(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new ArcPrimitive()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        center(obj) {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DVec3d= obj
         * @returns DVec3d|null
         */
        vector0(obj) {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? (obj || new DVec3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DVec3d= obj
         * @returns DVec3d|null
         */
        vector90(obj) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? (obj || new DVec3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        start() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        sweep() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns BoundaryType
         */
        boundary() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : BoundaryType.None;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startArcPrimitive(builder) {
            builder.startObject(6);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset centerOffset
         */
        static addCenter(builder, centerOffset) {
            builder.addFieldStruct(0, centerOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset vector0Offset
         */
        static addVector0(builder, vector0Offset) {
            builder.addFieldStruct(1, vector0Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset vector90Offset
         */
        static addVector90(builder, vector90Offset) {
            builder.addFieldStruct(2, vector90Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number start
         */
        static addStart(builder, start) {
            builder.addFieldFloat64(3, start, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number sweep
         */
        static addSweep(builder, sweep) {
            builder.addFieldFloat64(4, sweep, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param BoundaryType boundary
         */
        static addBoundary(builder, boundary) {
            builder.addFieldInt8(5, boundary, BoundaryType.None);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endArcPrimitive(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createArcPrimitive(builder, centerOffset, vector0Offset, vector90Offset, start, sweep, boundary) {
            ArcPrimitive.startArcPrimitive(builder);
            ArcPrimitive.addCenter(builder, centerOffset);
            ArcPrimitive.addVector0(builder, vector0Offset);
            ArcPrimitive.addVector90(builder, vector90Offset);
            ArcPrimitive.addStart(builder, start);
            ArcPrimitive.addSweep(builder, sweep);
            ArcPrimitive.addBoundary(builder, boundary);
            return ArcPrimitive.endArcPrimitive(builder);
        }
    }
    EGFBAccessors.ArcPrimitive = ArcPrimitive;
    /**
     * @constructor
     */
    class BRepData {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns BRepData
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param BRepData= obj
         * @returns BRepData
         */
        static getRootAsBRepData(bb, obj) {
            return (obj || new BRepData()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param BRepData= obj
         * @returns BRepData
         */
        static getSizePrefixedRootAsBRepData(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new BRepData()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param Transform= obj
         * @returns Transform|null
         */
        entityTransform(obj) {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? (obj || new Transform()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns BRepType
         */
        brepType() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : BRepType.Solid;
        }
        /**
         * @param number index
         * @returns number
         */
        entityData(index) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readUint8(this.bb.__vector(this.bb_pos + offset) + index) : 0;
        }
        /**
         * @returns number
         */
        entityDataLength() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Uint8Array
         */
        entityDataArray() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? new Uint8Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @param number index
         * @param FaceSymbology= obj
         * @returns FaceSymbology
         */
        symbology(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? (obj || new FaceSymbology()).__init(this.bb.__vector(this.bb_pos + offset) + index * 40, this.bb) : null;
        }
        /**
         * @returns number
         */
        symbologyLength() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @param number index
         * @param FaceSymbologyIndex= obj
         * @returns FaceSymbologyIndex
         */
        symbologyIndex(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? (obj || new FaceSymbologyIndex()).__init(this.bb.__vector(this.bb_pos + offset) + index * 8, this.bb) : null;
        }
        /**
         * @returns number
         */
        symbologyIndexLength() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startBRepData(builder) {
            builder.startObject(5);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset entityTransformOffset
         */
        static addEntityTransform(builder, entityTransformOffset) {
            builder.addFieldStruct(0, entityTransformOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param BRepType brepType
         */
        static addBrepType(builder, brepType) {
            builder.addFieldInt8(1, brepType, BRepType.Solid);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset entityDataOffset
         */
        static addEntityData(builder, entityDataOffset) {
            builder.addFieldOffset(2, entityDataOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createEntityDataVector(builder, data) {
            builder.startVector(1, data.length, 1);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addInt8(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startEntityDataVector(builder, numElems) {
            builder.startVector(1, numElems, 1);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset symbologyOffset
         */
        static addSymbology(builder, symbologyOffset) {
            builder.addFieldOffset(3, symbologyOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startSymbologyVector(builder, numElems) {
            builder.startVector(40, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset symbologyIndexOffset
         */
        static addSymbologyIndex(builder, symbologyIndexOffset) {
            builder.addFieldOffset(4, symbologyIndexOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startSymbologyIndexVector(builder, numElems) {
            builder.startVector(8, numElems, 4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endBRepData(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createBRepData(builder, entityTransformOffset, brepType, entityDataOffset, symbologyOffset, symbologyIndexOffset) {
            BRepData.startBRepData(builder);
            BRepData.addEntityTransform(builder, entityTransformOffset);
            BRepData.addBrepType(builder, brepType);
            BRepData.addEntityData(builder, entityDataOffset);
            BRepData.addSymbology(builder, symbologyOffset);
            BRepData.addSymbologyIndex(builder, symbologyIndexOffset);
            return BRepData.endBRepData(builder);
        }
    }
    EGFBAccessors.BRepData = BRepData;
    /**
     * @constructor
     */
    class Image {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns Image
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param Image= obj
         * @returns Image
         */
        static getRootAsImage(bb, obj) {
            return (obj || new Image()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param Image= obj
         * @returns Image
         */
        static getSizePrefixedRootAsImage(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new Image()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        drawBorder() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useFillTint() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        tileCorner0(obj) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        tileCorner1(obj) {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        tileCorner2(obj) {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        tileCorner3(obj) {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        width() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        height() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        format() {
            var offset = this.bb.__offset(this.bb_pos, 20);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @param number index
         * @returns number
         */
        byteData(index) {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.readUint8(this.bb.__vector(this.bb_pos + offset) + index) : 0;
        }
        /**
         * @returns number
         */
        byteDataLength() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Uint8Array
         */
        byteDataArray() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? new Uint8Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @returns flatbuffers.Long
         */
        textureId() {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startImage(builder) {
            builder.startObject(11);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number drawBorder
         */
        static addDrawBorder(builder, drawBorder) {
            builder.addFieldInt8(0, drawBorder, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useFillTint
         */
        static addUseFillTint(builder, useFillTint) {
            builder.addFieldInt8(1, useFillTint, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset tileCorner0Offset
         */
        static addTileCorner0(builder, tileCorner0Offset) {
            builder.addFieldStruct(2, tileCorner0Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset tileCorner1Offset
         */
        static addTileCorner1(builder, tileCorner1Offset) {
            builder.addFieldStruct(3, tileCorner1Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset tileCorner2Offset
         */
        static addTileCorner2(builder, tileCorner2Offset) {
            builder.addFieldStruct(4, tileCorner2Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset tileCorner3Offset
         */
        static addTileCorner3(builder, tileCorner3Offset) {
            builder.addFieldStruct(5, tileCorner3Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number width
         */
        static addWidth(builder, width) {
            builder.addFieldInt32(6, width, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number height
         */
        static addHeight(builder, height) {
            builder.addFieldInt32(7, height, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number format
         */
        static addFormat(builder, format) {
            builder.addFieldInt32(8, format, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset byteDataOffset
         */
        static addByteData(builder, byteDataOffset) {
            builder.addFieldOffset(9, byteDataOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createByteDataVector(builder, data) {
            builder.startVector(1, data.length, 1);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addInt8(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startByteDataVector(builder, numElems) {
            builder.startVector(1, numElems, 1);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long textureId
         */
        static addTextureId(builder, textureId) {
            builder.addFieldInt64(10, textureId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endImage(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createImage(builder, drawBorder, useFillTint, tileCorner0Offset, tileCorner1Offset, tileCorner2Offset, tileCorner3Offset, width, height, format, byteDataOffset, textureId) {
            Image.startImage(builder);
            Image.addDrawBorder(builder, drawBorder);
            Image.addUseFillTint(builder, useFillTint);
            Image.addTileCorner0(builder, tileCorner0Offset);
            Image.addTileCorner1(builder, tileCorner1Offset);
            Image.addTileCorner2(builder, tileCorner2Offset);
            Image.addTileCorner3(builder, tileCorner3Offset);
            Image.addWidth(builder, width);
            Image.addHeight(builder, height);
            Image.addFormat(builder, format);
            Image.addByteData(builder, byteDataOffset);
            Image.addTextureId(builder, textureId);
            return Image.endImage(builder);
        }
    }
    EGFBAccessors.Image = Image;
    /**
     * @constructor
     */
    class GeometryPart {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns GeometryPart
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param GeometryPart= obj
         * @returns GeometryPart
         */
        static getRootAsGeometryPart(bb, obj) {
            return (obj || new GeometryPart()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param GeometryPart= obj
         * @returns GeometryPart
         */
        static getSizePrefixedRootAsGeometryPart(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new GeometryPart()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns flatbuffers.Long
         */
        geomPartId() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        origin(obj) {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        yaw() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        pitch() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        roll() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        scale() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 1.0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startGeometryPart(builder) {
            builder.startObject(6);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long geomPartId
         */
        static addGeomPartId(builder, geomPartId) {
            builder.addFieldInt64(0, geomPartId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset originOffset
         */
        static addOrigin(builder, originOffset) {
            builder.addFieldStruct(1, originOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number yaw
         */
        static addYaw(builder, yaw) {
            builder.addFieldFloat64(2, yaw, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number pitch
         */
        static addPitch(builder, pitch) {
            builder.addFieldFloat64(3, pitch, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number roll
         */
        static addRoll(builder, roll) {
            builder.addFieldFloat64(4, roll, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number scale
         */
        static addScale(builder, scale) {
            builder.addFieldFloat64(5, scale, 1.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endGeometryPart(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createGeometryPart(builder, geomPartId, originOffset, yaw, pitch, roll, scale) {
            GeometryPart.startGeometryPart(builder);
            GeometryPart.addGeomPartId(builder, geomPartId);
            GeometryPart.addOrigin(builder, originOffset);
            GeometryPart.addYaw(builder, yaw);
            GeometryPart.addPitch(builder, pitch);
            GeometryPart.addRoll(builder, roll);
            GeometryPart.addScale(builder, scale);
            return GeometryPart.endGeometryPart(builder);
        }
    }
    EGFBAccessors.GeometryPart = GeometryPart;
    /**
     * @constructor
     */
    class BasicSymbology {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns BasicSymbology
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param BasicSymbology= obj
         * @returns BasicSymbology
         */
        static getRootAsBasicSymbology(bb, obj) {
            return (obj || new BasicSymbology()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param BasicSymbology= obj
         * @returns BasicSymbology
         */
        static getSizePrefixedRootAsBasicSymbology(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new BasicSymbology()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns flatbuffers.Long
         */
        subCategoryId() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @returns number
         */
        color() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        weight() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns flatbuffers.Long
         */
        lineStyleId() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @returns number
         */
        transparency() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        displayPriority() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? this.bb.readInt32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns GeometryClass
         */
        geomClass() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : GeometryClass.Primary;
        }
        /**
         * @returns number
         */
        useColor() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useWeight() {
            var offset = this.bb.__offset(this.bb_pos, 20);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useStyle() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startBasicSymbology(builder) {
            builder.startObject(10);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long subCategoryId
         */
        static addSubCategoryId(builder, subCategoryId) {
            builder.addFieldInt64(0, subCategoryId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number color
         */
        static addColor(builder, color) {
            builder.addFieldInt32(1, color, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number weight
         */
        static addWeight(builder, weight) {
            builder.addFieldInt32(2, weight, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long lineStyleId
         */
        static addLineStyleId(builder, lineStyleId) {
            builder.addFieldInt64(3, lineStyleId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number transparency
         */
        static addTransparency(builder, transparency) {
            builder.addFieldFloat64(4, transparency, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number displayPriority
         */
        static addDisplayPriority(builder, displayPriority) {
            builder.addFieldInt32(5, displayPriority, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param GeometryClass geomClass
         */
        static addGeomClass(builder, geomClass) {
            builder.addFieldInt8(6, geomClass, GeometryClass.Primary);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useColor
         */
        static addUseColor(builder, useColor) {
            builder.addFieldInt8(7, useColor, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useWeight
         */
        static addUseWeight(builder, useWeight) {
            builder.addFieldInt8(8, useWeight, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useStyle
         */
        static addUseStyle(builder, useStyle) {
            builder.addFieldInt8(9, useStyle, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endBasicSymbology(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createBasicSymbology(builder, subCategoryId, color, weight, lineStyleId, transparency, displayPriority, geomClass, useColor, useWeight, useStyle) {
            BasicSymbology.startBasicSymbology(builder);
            BasicSymbology.addSubCategoryId(builder, subCategoryId);
            BasicSymbology.addColor(builder, color);
            BasicSymbology.addWeight(builder, weight);
            BasicSymbology.addLineStyleId(builder, lineStyleId);
            BasicSymbology.addTransparency(builder, transparency);
            BasicSymbology.addDisplayPriority(builder, displayPriority);
            BasicSymbology.addGeomClass(builder, geomClass);
            BasicSymbology.addUseColor(builder, useColor);
            BasicSymbology.addUseWeight(builder, useWeight);
            BasicSymbology.addUseStyle(builder, useStyle);
            return BasicSymbology.endBasicSymbology(builder);
        }
    }
    EGFBAccessors.BasicSymbology = BasicSymbology;
    /**
     * @constructor
     */
    class LineStyleModifiers {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns LineStyleModifiers
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param LineStyleModifiers= obj
         * @returns LineStyleModifiers
         */
        static getRootAsLineStyleModifiers(bb, obj) {
            return (obj || new LineStyleModifiers()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param LineStyleModifiers= obj
         * @returns LineStyleModifiers
         */
        static getSizePrefixedRootAsLineStyleModifiers(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new LineStyleModifiers()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        modifiers() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        scale() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        dashScale() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        gapScale() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        startWidth() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        endWidth() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        distPhase() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        fractPhase() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        normal(obj) {
            var offset = this.bb.__offset(this.bb_pos, 20);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        yaw() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        pitch() {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        roll() {
            var offset = this.bb.__offset(this.bb_pos, 26);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startLineStyleModifiers(builder) {
            builder.startObject(12);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number modifiers
         */
        static addModifiers(builder, modifiers) {
            builder.addFieldInt32(0, modifiers, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number scale
         */
        static addScale(builder, scale) {
            builder.addFieldFloat64(1, scale, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number dashScale
         */
        static addDashScale(builder, dashScale) {
            builder.addFieldFloat64(2, dashScale, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number gapScale
         */
        static addGapScale(builder, gapScale) {
            builder.addFieldFloat64(3, gapScale, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number startWidth
         */
        static addStartWidth(builder, startWidth) {
            builder.addFieldFloat64(4, startWidth, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number endWidth
         */
        static addEndWidth(builder, endWidth) {
            builder.addFieldFloat64(5, endWidth, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number distPhase
         */
        static addDistPhase(builder, distPhase) {
            builder.addFieldFloat64(6, distPhase, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number fractPhase
         */
        static addFractPhase(builder, fractPhase) {
            builder.addFieldFloat64(7, fractPhase, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset normalOffset
         */
        static addNormal(builder, normalOffset) {
            builder.addFieldStruct(8, normalOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number yaw
         */
        static addYaw(builder, yaw) {
            builder.addFieldFloat64(9, yaw, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number pitch
         */
        static addPitch(builder, pitch) {
            builder.addFieldFloat64(10, pitch, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number roll
         */
        static addRoll(builder, roll) {
            builder.addFieldFloat64(11, roll, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endLineStyleModifiers(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createLineStyleModifiers(builder, modifiers, scale, dashScale, gapScale, startWidth, endWidth, distPhase, fractPhase, normalOffset, yaw, pitch, roll) {
            LineStyleModifiers.startLineStyleModifiers(builder);
            LineStyleModifiers.addModifiers(builder, modifiers);
            LineStyleModifiers.addScale(builder, scale);
            LineStyleModifiers.addDashScale(builder, dashScale);
            LineStyleModifiers.addGapScale(builder, gapScale);
            LineStyleModifiers.addStartWidth(builder, startWidth);
            LineStyleModifiers.addEndWidth(builder, endWidth);
            LineStyleModifiers.addDistPhase(builder, distPhase);
            LineStyleModifiers.addFractPhase(builder, fractPhase);
            LineStyleModifiers.addNormal(builder, normalOffset);
            LineStyleModifiers.addYaw(builder, yaw);
            LineStyleModifiers.addPitch(builder, pitch);
            LineStyleModifiers.addRoll(builder, roll);
            return LineStyleModifiers.endLineStyleModifiers(builder);
        }
    }
    EGFBAccessors.LineStyleModifiers = LineStyleModifiers;
    /**
     * @constructor
     */
    class Material {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns Material
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param Material= obj
         * @returns Material
         */
        static getRootAsMaterial(bb, obj) {
            return (obj || new Material()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param Material= obj
         * @returns Material
         */
        static getSizePrefixedRootAsMaterial(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new Material()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        useMaterial() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns flatbuffers.Long
         */
        materialId() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        origin(obj) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        size(obj) {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        yaw() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        pitch() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        roll() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param Trans2x3= obj
         * @returns Trans2x3|null
         */
        trans2x3(obj) {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? (obj || new Trans2x3()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startMaterial(builder) {
            builder.startObject(8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useMaterial
         */
        static addUseMaterial(builder, useMaterial) {
            builder.addFieldInt8(0, useMaterial, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long materialId
         */
        static addMaterialId(builder, materialId) {
            builder.addFieldInt64(1, materialId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset originOffset
         */
        static addOrigin(builder, originOffset) {
            builder.addFieldStruct(2, originOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset sizeOffset
         */
        static addSize(builder, sizeOffset) {
            builder.addFieldStruct(3, sizeOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number yaw
         */
        static addYaw(builder, yaw) {
            builder.addFieldFloat64(4, yaw, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number pitch
         */
        static addPitch(builder, pitch) {
            builder.addFieldFloat64(5, pitch, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number roll
         */
        static addRoll(builder, roll) {
            builder.addFieldFloat64(6, roll, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset trans2x3Offset
         */
        static addTrans2x3(builder, trans2x3Offset) {
            builder.addFieldStruct(7, trans2x3Offset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endMaterial(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createMaterial(builder, useMaterial, materialId, originOffset, sizeOffset, yaw, pitch, roll, trans2x3Offset) {
            Material.startMaterial(builder);
            Material.addUseMaterial(builder, useMaterial);
            Material.addMaterialId(builder, materialId);
            Material.addOrigin(builder, originOffset);
            Material.addSize(builder, sizeOffset);
            Material.addYaw(builder, yaw);
            Material.addPitch(builder, pitch);
            Material.addRoll(builder, roll);
            Material.addTrans2x3(builder, trans2x3Offset);
            return Material.endMaterial(builder);
        }
    }
    EGFBAccessors.Material = Material;
    /**
     * @constructor
     */
    class ThematicSettings {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns ThematicSettings
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param ThematicSettings= obj
         * @returns ThematicSettings
         */
        static getRootAsThematicSettings(bb, obj) {
            return (obj || new ThematicSettings()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param ThematicSettings= obj
         * @returns ThematicSettings
         */
        static getSizePrefixedRootAsThematicSettings(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new ThematicSettings()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        stepCount() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        margin() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        marginColor() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        mode() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        colorScheme() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @param DRange1d= obj
         * @returns DRange1d|null
         */
        range(obj) {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? (obj || new DRange1d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startThematicSettings(builder) {
            builder.startObject(6);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number stepCount
         */
        static addStepCount(builder, stepCount) {
            builder.addFieldInt32(0, stepCount, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number margin
         */
        static addMargin(builder, margin) {
            builder.addFieldFloat64(1, margin, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number marginColor
         */
        static addMarginColor(builder, marginColor) {
            builder.addFieldInt32(2, marginColor, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number mode
         */
        static addMode(builder, mode) {
            builder.addFieldInt32(3, mode, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number colorScheme
         */
        static addColorScheme(builder, colorScheme) {
            builder.addFieldInt32(4, colorScheme, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset rangeOffset
         */
        static addRange(builder, rangeOffset) {
            builder.addFieldStruct(5, rangeOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endThematicSettings(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createThematicSettings(builder, stepCount, margin, marginColor, mode, colorScheme, rangeOffset) {
            ThematicSettings.startThematicSettings(builder);
            ThematicSettings.addStepCount(builder, stepCount);
            ThematicSettings.addMargin(builder, margin);
            ThematicSettings.addMarginColor(builder, marginColor);
            ThematicSettings.addMode(builder, mode);
            ThematicSettings.addColorScheme(builder, colorScheme);
            ThematicSettings.addRange(builder, rangeOffset);
            return ThematicSettings.endThematicSettings(builder);
        }
    }
    EGFBAccessors.ThematicSettings = ThematicSettings;
    /**
     * @constructor
     */
    class AreaFill {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns AreaFill
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param AreaFill= obj
         * @returns AreaFill
         */
        static getRootAsAreaFill(bb, obj) {
            return (obj || new AreaFill()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param AreaFill= obj
         * @returns AreaFill
         */
        static getSizePrefixedRootAsAreaFill(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new AreaFill()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns FillDisplay
         */
        fill() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : FillDisplay.None;
        }
        /**
         * @returns number
         */
        color() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useColor() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        backgroundFill() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        transparency() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns GradientMode
         */
        mode() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? /**  */ (this.bb.readInt8(this.bb_pos + offset)) : GradientMode.None;
        }
        /**
         * @returns number
         */
        flags() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readUint16(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        angle() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        tint() {
            var offset = this.bb.__offset(this.bb_pos, 20);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        shift() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param number index
         * @returns number
         */
        colors(index) {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? this.bb.readUint32(this.bb.__vector(this.bb_pos + offset) + index * 4) : 0;
        }
        /**
         * @returns number
         */
        colorsLength() {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Uint32Array
         */
        colorsArray() {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? new Uint32Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @param number index
         * @returns number
         */
        values(index) {
            var offset = this.bb.__offset(this.bb_pos, 26);
            return offset ? this.bb.readFloat64(this.bb.__vector(this.bb_pos + offset) + index * 8) : 0;
        }
        /**
         * @returns number
         */
        valuesLength() {
            var offset = this.bb.__offset(this.bb_pos, 26);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Float64Array
         */
        valuesArray() {
            var offset = this.bb.__offset(this.bb_pos, 26);
            return offset ? new Float64Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @param ThematicSettings= obj
         * @returns ThematicSettings|null
         */
        thematicSettings(obj) {
            var offset = this.bb.__offset(this.bb_pos, 28);
            return offset ? (obj || new ThematicSettings()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startAreaFill(builder) {
            builder.startObject(13);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param FillDisplay fill
         */
        static addFill(builder, fill) {
            builder.addFieldInt8(0, fill, FillDisplay.None);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number color
         */
        static addColor(builder, color) {
            builder.addFieldInt32(1, color, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useColor
         */
        static addUseColor(builder, useColor) {
            builder.addFieldInt8(2, useColor, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number backgroundFill
         */
        static addBackgroundFill(builder, backgroundFill) {
            builder.addFieldInt8(3, backgroundFill, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number transparency
         */
        static addTransparency(builder, transparency) {
            builder.addFieldFloat64(4, transparency, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param GradientMode mode
         */
        static addMode(builder, mode) {
            builder.addFieldInt8(5, mode, GradientMode.None);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number flags
         */
        static addFlags(builder, flags) {
            builder.addFieldInt16(6, flags, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number angle
         */
        static addAngle(builder, angle) {
            builder.addFieldFloat64(7, angle, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number tint
         */
        static addTint(builder, tint) {
            builder.addFieldFloat64(8, tint, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number shift
         */
        static addShift(builder, shift) {
            builder.addFieldFloat64(9, shift, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset colorsOffset
         */
        static addColors(builder, colorsOffset) {
            builder.addFieldOffset(10, colorsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createColorsVector(builder, data) {
            builder.startVector(4, data.length, 4);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addInt32(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startColorsVector(builder, numElems) {
            builder.startVector(4, numElems, 4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset valuesOffset
         */
        static addValues(builder, valuesOffset) {
            builder.addFieldOffset(11, valuesOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createValuesVector(builder, data) {
            builder.startVector(8, data.length, 8);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addFloat64(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startValuesVector(builder, numElems) {
            builder.startVector(8, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset thematicSettingsOffset
         */
        static addThematicSettings(builder, thematicSettingsOffset) {
            builder.addFieldOffset(12, thematicSettingsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endAreaFill(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createAreaFill(builder, fill, color, useColor, backgroundFill, transparency, mode, flags, angle, tint, shift, colorsOffset, valuesOffset, thematicSettingsOffset) {
            AreaFill.startAreaFill(builder);
            AreaFill.addFill(builder, fill);
            AreaFill.addColor(builder, color);
            AreaFill.addUseColor(builder, useColor);
            AreaFill.addBackgroundFill(builder, backgroundFill);
            AreaFill.addTransparency(builder, transparency);
            AreaFill.addMode(builder, mode);
            AreaFill.addFlags(builder, flags);
            AreaFill.addAngle(builder, angle);
            AreaFill.addTint(builder, tint);
            AreaFill.addShift(builder, shift);
            AreaFill.addColors(builder, colorsOffset);
            AreaFill.addValues(builder, valuesOffset);
            AreaFill.addThematicSettings(builder, thematicSettingsOffset);
            return AreaFill.endAreaFill(builder);
        }
    }
    EGFBAccessors.AreaFill = AreaFill;
    /**
     * @constructor
     */
    class DwgHatchDefLine {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns DwgHatchDefLine
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param DwgHatchDefLine= obj
         * @returns DwgHatchDefLine
         */
        static getRootAsDwgHatchDefLine(bb, obj) {
            return (obj || new DwgHatchDefLine()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param DwgHatchDefLine= obj
         * @returns DwgHatchDefLine
         */
        static getSizePrefixedRootAsDwgHatchDefLine(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new DwgHatchDefLine()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        angle() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param DPoint2d= obj
         * @returns DPoint2d|null
         */
        through(obj) {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? (obj || new DPoint2d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param DPoint2d= obj
         * @returns DPoint2d|null
         */
        offset(obj) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? (obj || new DPoint2d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param number index
         * @returns number
         */
        dashes(index) {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readFloat64(this.bb.__vector(this.bb_pos + offset) + index * 8) : 0;
        }
        /**
         * @returns number
         */
        dashesLength() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Float64Array
         */
        dashesArray() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? new Float64Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startDwgHatchDefLine(builder) {
            builder.startObject(4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number angle
         */
        static addAngle(builder, angle) {
            builder.addFieldFloat64(0, angle, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset throughOffset
         */
        static addThrough(builder, throughOffset) {
            builder.addFieldStruct(1, throughOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset offsetOffset
         */
        static addOffset(builder, offsetOffset) {
            builder.addFieldStruct(2, offsetOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset dashesOffset
         */
        static addDashes(builder, dashesOffset) {
            builder.addFieldOffset(3, dashesOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createDashesVector(builder, data) {
            builder.startVector(8, data.length, 8);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addFloat64(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startDashesVector(builder, numElems) {
            builder.startVector(8, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endDwgHatchDefLine(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createDwgHatchDefLine(builder, angle, throughOffset, offsetOffset, dashesOffset) {
            DwgHatchDefLine.startDwgHatchDefLine(builder);
            DwgHatchDefLine.addAngle(builder, angle);
            DwgHatchDefLine.addThrough(builder, throughOffset);
            DwgHatchDefLine.addOffset(builder, offsetOffset);
            DwgHatchDefLine.addDashes(builder, dashesOffset);
            return DwgHatchDefLine.endDwgHatchDefLine(builder);
        }
    }
    EGFBAccessors.DwgHatchDefLine = DwgHatchDefLine;
    /**
     * @constructor
     */
    class AreaPattern {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns AreaPattern
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param AreaPattern= obj
         * @returns AreaPattern
         */
        static getRootAsAreaPattern(bb, obj) {
            return (obj || new AreaPattern()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param AreaPattern= obj
         * @returns AreaPattern
         */
        static getSizePrefixedRootAsAreaPattern(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new AreaPattern()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param DPoint3d= obj
         * @returns DPoint3d|null
         */
        origin(obj) {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? (obj || new DPoint3d()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param RotMatrix= obj
         * @returns RotMatrix|null
         */
        rotation(obj) {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? (obj || new RotMatrix()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @returns number
         */
        space1() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        space2() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        angle1() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        angle2() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        scale() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        color() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        weight() {
            var offset = this.bb.__offset(this.bb_pos, 20);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useColor() {
            var offset = this.bb.__offset(this.bb_pos, 22);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        useWeight() {
            var offset = this.bb.__offset(this.bb_pos, 24);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        invisibleBoundary() {
            var offset = this.bb.__offset(this.bb_pos, 26);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        snappable() {
            var offset = this.bb.__offset(this.bb_pos, 28);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns flatbuffers.Long
         */
        symbolId() {
            var offset = this.bb.__offset(this.bb_pos, 30);
            return offset ? this.bb.readInt64(this.bb_pos + offset) : this.bb.createLong(0, 0);
        }
        /**
         * @param number index
         * @param DwgHatchDefLine= obj
         * @returns DwgHatchDefLine
         */
        defLine(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 32);
            return offset ? (obj || new DwgHatchDefLine()).__init(this.bb.__indirect(this.bb.__vector(this.bb_pos + offset) + index * 4), this.bb) : null;
        }
        /**
         * @returns number
         */
        defLineLength() {
            var offset = this.bb.__offset(this.bb_pos, 32);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startAreaPattern(builder) {
            builder.startObject(15);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset originOffset
         */
        static addOrigin(builder, originOffset) {
            builder.addFieldStruct(0, originOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset rotationOffset
         */
        static addRotation(builder, rotationOffset) {
            builder.addFieldStruct(1, rotationOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number space1
         */
        static addSpace1(builder, space1) {
            builder.addFieldFloat64(2, space1, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number space2
         */
        static addSpace2(builder, space2) {
            builder.addFieldFloat64(3, space2, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number angle1
         */
        static addAngle1(builder, angle1) {
            builder.addFieldFloat64(4, angle1, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number angle2
         */
        static addAngle2(builder, angle2) {
            builder.addFieldFloat64(5, angle2, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number scale
         */
        static addScale(builder, scale) {
            builder.addFieldFloat64(6, scale, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number color
         */
        static addColor(builder, color) {
            builder.addFieldInt32(7, color, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number weight
         */
        static addWeight(builder, weight) {
            builder.addFieldInt32(8, weight, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useColor
         */
        static addUseColor(builder, useColor) {
            builder.addFieldInt8(9, useColor, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number useWeight
         */
        static addUseWeight(builder, useWeight) {
            builder.addFieldInt8(10, useWeight, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number invisibleBoundary
         */
        static addInvisibleBoundary(builder, invisibleBoundary) {
            builder.addFieldInt8(11, invisibleBoundary, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number snappable
         */
        static addSnappable(builder, snappable) {
            builder.addFieldInt8(12, snappable, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Long symbolId
         */
        static addSymbolId(builder, symbolId) {
            builder.addFieldInt64(13, symbolId, builder.createLong(0, 0));
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset defLineOffset
         */
        static addDefLine(builder, defLineOffset) {
            builder.addFieldOffset(14, defLineOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<flatbuffers.Offset> data
         * @returns flatbuffers.Offset
         */
        static createDefLineVector(builder, data) {
            builder.startVector(4, data.length, 4);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addOffset(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startDefLineVector(builder, numElems) {
            builder.startVector(4, numElems, 4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endAreaPattern(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createAreaPattern(builder, originOffset, rotationOffset, space1, space2, angle1, angle2, scale, color, weight, useColor, useWeight, invisibleBoundary, snappable, symbolId, defLineOffset) {
            AreaPattern.startAreaPattern(builder);
            AreaPattern.addOrigin(builder, originOffset);
            AreaPattern.addRotation(builder, rotationOffset);
            AreaPattern.addSpace1(builder, space1);
            AreaPattern.addSpace2(builder, space2);
            AreaPattern.addAngle1(builder, angle1);
            AreaPattern.addAngle2(builder, angle2);
            AreaPattern.addScale(builder, scale);
            AreaPattern.addColor(builder, color);
            AreaPattern.addWeight(builder, weight);
            AreaPattern.addUseColor(builder, useColor);
            AreaPattern.addUseWeight(builder, useWeight);
            AreaPattern.addInvisibleBoundary(builder, invisibleBoundary);
            AreaPattern.addSnappable(builder, snappable);
            AreaPattern.addSymbolId(builder, symbolId);
            AreaPattern.addDefLine(builder, defLineOffset);
            return AreaPattern.endAreaPattern(builder);
        }
    }
    EGFBAccessors.AreaPattern = AreaPattern;
    /**
     * @constructor
     */
    class TextStringTransform {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns TextStringTransform
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        form3d00() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        form3d01() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        form3d02() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @returns number
         */
        form3d03() {
            return this.bb.readFloat64(this.bb_pos + 24);
        }
        /**
         * @returns number
         */
        form3d10() {
            return this.bb.readFloat64(this.bb_pos + 32);
        }
        /**
         * @returns number
         */
        form3d11() {
            return this.bb.readFloat64(this.bb_pos + 40);
        }
        /**
         * @returns number
         */
        form3d12() {
            return this.bb.readFloat64(this.bb_pos + 48);
        }
        /**
         * @returns number
         */
        form3d13() {
            return this.bb.readFloat64(this.bb_pos + 56);
        }
        /**
         * @returns number
         */
        form3d20() {
            return this.bb.readFloat64(this.bb_pos + 64);
        }
        /**
         * @returns number
         */
        form3d21() {
            return this.bb.readFloat64(this.bb_pos + 72);
        }
        /**
         * @returns number
         */
        form3d22() {
            return this.bb.readFloat64(this.bb_pos + 80);
        }
        /**
         * @returns number
         */
        form3d23() {
            return this.bb.readFloat64(this.bb_pos + 88);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number form3d00
         * @param number form3d01
         * @param number form3d02
         * @param number form3d03
         * @param number form3d10
         * @param number form3d11
         * @param number form3d12
         * @param number form3d13
         * @param number form3d20
         * @param number form3d21
         * @param number form3d22
         * @param number form3d23
         * @returns flatbuffers.Offset
         */
        static createTextStringTransform(builder, form3d00, form3d01, form3d02, form3d03, form3d10, form3d11, form3d12, form3d13, form3d20, form3d21, form3d22, form3d23) {
            builder.prep(8, 96);
            builder.writeFloat64(form3d23);
            builder.writeFloat64(form3d22);
            builder.writeFloat64(form3d21);
            builder.writeFloat64(form3d20);
            builder.writeFloat64(form3d13);
            builder.writeFloat64(form3d12);
            builder.writeFloat64(form3d11);
            builder.writeFloat64(form3d10);
            builder.writeFloat64(form3d03);
            builder.writeFloat64(form3d02);
            builder.writeFloat64(form3d01);
            builder.writeFloat64(form3d00);
            return builder.offset();
        }
    }
    EGFBAccessors.TextStringTransform = TextStringTransform;
    /**
     * @constructor
     */
    class TextStringRange {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns TextStringRange
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        lowx() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        lowy() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @returns number
         */
        highx() {
            return this.bb.readFloat64(this.bb_pos + 16);
        }
        /**
         * @returns number
         */
        highy() {
            return this.bb.readFloat64(this.bb_pos + 24);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number lowx
         * @param number lowy
         * @param number highx
         * @param number highy
         * @returns flatbuffers.Offset
         */
        static createTextStringRange(builder, lowx, lowy, highx, highy) {
            builder.prep(8, 32);
            builder.writeFloat64(highy);
            builder.writeFloat64(highx);
            builder.writeFloat64(lowy);
            builder.writeFloat64(lowx);
            return builder.offset();
        }
    }
    EGFBAccessors.TextStringRange = TextStringRange;
    /**
     * @constructor
     */
    class TextStringGlyphOrigin {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns TextStringGlyphOrigin
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @returns number
         */
        x() {
            return this.bb.readFloat64(this.bb_pos);
        }
        /**
         * @returns number
         */
        y() {
            return this.bb.readFloat64(this.bb_pos + 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number x
         * @param number y
         * @returns flatbuffers.Offset
         */
        static createTextStringGlyphOrigin(builder, x, y) {
            builder.prep(8, 16);
            builder.writeFloat64(y);
            builder.writeFloat64(x);
            return builder.offset();
        }
    }
    EGFBAccessors.TextStringGlyphOrigin = TextStringGlyphOrigin;
    /**
     * @constructor
     */
    class TextStringStyle {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns TextStringStyle
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param TextStringStyle= obj
         * @returns TextStringStyle
         */
        static getRootAsTextStringStyle(bb, obj) {
            return (obj || new TextStringStyle()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param TextStringStyle= obj
         * @returns TextStringStyle
         */
        static getSizePrefixedRootAsTextStringStyle(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new TextStringStyle()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        majorVersion() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        minorVersion() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        fontId() {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.readUint32(this.bb_pos + offset) : 0;
        }
        /**
         * @returns boolean
         */
        isBold() {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? !!this.bb.readInt8(this.bb_pos + offset) : false;
        }
        /**
         * @returns boolean
         */
        isItalic() {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? !!this.bb.readInt8(this.bb_pos + offset) : false;
        }
        /**
         * @returns boolean
         */
        isUnderlined() {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? !!this.bb.readInt8(this.bb_pos + offset) : false;
        }
        /**
         * @returns number
         */
        height() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @returns number
         */
        widthFactor() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.readFloat64(this.bb_pos + offset) : 0.0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startTextStringStyle(builder) {
            builder.startObject(8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number majorVersion
         */
        static addMajorVersion(builder, majorVersion) {
            builder.addFieldInt8(0, majorVersion, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number minorVersion
         */
        static addMinorVersion(builder, minorVersion) {
            builder.addFieldInt8(1, minorVersion, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number fontId
         */
        static addFontId(builder, fontId) {
            builder.addFieldInt32(2, fontId, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param boolean isBold
         */
        static addIsBold(builder, isBold) {
            builder.addFieldInt8(3, +isBold, +false);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param boolean isItalic
         */
        static addIsItalic(builder, isItalic) {
            builder.addFieldInt8(4, +isItalic, +false);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param boolean isUnderlined
         */
        static addIsUnderlined(builder, isUnderlined) {
            builder.addFieldInt8(5, +isUnderlined, +false);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number height
         */
        static addHeight(builder, height) {
            builder.addFieldFloat64(6, height, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number widthFactor
         */
        static addWidthFactor(builder, widthFactor) {
            builder.addFieldFloat64(7, widthFactor, 0.0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endTextStringStyle(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createTextStringStyle(builder, majorVersion, minorVersion, fontId, isBold, isItalic, isUnderlined, height, widthFactor) {
            TextStringStyle.startTextStringStyle(builder);
            TextStringStyle.addMajorVersion(builder, majorVersion);
            TextStringStyle.addMinorVersion(builder, minorVersion);
            TextStringStyle.addFontId(builder, fontId);
            TextStringStyle.addIsBold(builder, isBold);
            TextStringStyle.addIsItalic(builder, isItalic);
            TextStringStyle.addIsUnderlined(builder, isUnderlined);
            TextStringStyle.addHeight(builder, height);
            TextStringStyle.addWidthFactor(builder, widthFactor);
            return TextStringStyle.endTextStringStyle(builder);
        }
    }
    EGFBAccessors.TextStringStyle = TextStringStyle;
    /**
     * @constructor
     */
    class TextString {
        constructor() {
            this.bb = null;
            this.bb_pos = 0;
        }
        /**
         * @param number i
         * @param flatbuffers.ByteBuffer bb
         * @returns TextString
         */
        __init(i, bb) {
            this.bb_pos = i;
            this.bb = bb;
            return this;
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param TextString= obj
         * @returns TextString
         */
        static getRootAsTextString(bb, obj) {
            return (obj || new TextString()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @param flatbuffers.ByteBuffer bb
         * @param TextString= obj
         * @returns TextString
         */
        static getSizePrefixedRootAsTextString(bb, obj) {
            bb.setPosition(bb.position() + flatbuffers_1.flatbuffers.SIZE_PREFIX_LENGTH);
            return (obj || new TextString()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
        }
        /**
         * @returns number
         */
        majorVersion() {
            var offset = this.bb.__offset(this.bb_pos, 4);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        /**
         * @returns number
         */
        minorVersion() {
            var offset = this.bb.__offset(this.bb_pos, 6);
            return offset ? this.bb.readUint8(this.bb_pos + offset) : 0;
        }
        text(optionalEncoding) {
            var offset = this.bb.__offset(this.bb_pos, 8);
            return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
        }
        /**
         * @param TextStringStyle= obj
         * @returns TextStringStyle|null
         */
        style(obj) {
            var offset = this.bb.__offset(this.bb_pos, 10);
            return offset ? (obj || new TextStringStyle()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
        }
        /**
         * @param TextStringTransform= obj
         * @returns TextStringTransform|null
         */
        transform(obj) {
            var offset = this.bb.__offset(this.bb_pos, 12);
            return offset ? (obj || new TextStringTransform()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param TextStringRange= obj
         * @returns TextStringRange|null
         */
        range(obj) {
            var offset = this.bb.__offset(this.bb_pos, 14);
            return offset ? (obj || new TextStringRange()).__init(this.bb_pos + offset, this.bb) : null;
        }
        /**
         * @param number index
         * @returns number
         */
        glyphIds(index) {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.readUint32(this.bb.__vector(this.bb_pos + offset) + index * 4) : 0;
        }
        /**
         * @returns number
         */
        glyphIdsLength() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @returns Uint32Array
         */
        glyphIdsArray() {
            var offset = this.bb.__offset(this.bb_pos, 16);
            return offset ? new Uint32Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
        }
        /**
         * @param number index
         * @param TextStringGlyphOrigin= obj
         * @returns TextStringGlyphOrigin
         */
        glyphOrigins(index, obj) {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? (obj || new TextStringGlyphOrigin()).__init(this.bb.__vector(this.bb_pos + offset) + index * 16, this.bb) : null;
        }
        /**
         * @returns number
         */
        glyphOriginsLength() {
            var offset = this.bb.__offset(this.bb_pos, 18);
            return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
        }
        /**
         * @param flatbuffers.Builder builder
         */
        static startTextString(builder) {
            builder.startObject(8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number majorVersion
         */
        static addMajorVersion(builder, majorVersion) {
            builder.addFieldInt8(0, majorVersion, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number minorVersion
         */
        static addMinorVersion(builder, minorVersion) {
            builder.addFieldInt8(1, minorVersion, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset textOffset
         */
        static addText(builder, textOffset) {
            builder.addFieldOffset(2, textOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset styleOffset
         */
        static addStyle(builder, styleOffset) {
            builder.addFieldOffset(3, styleOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset transformOffset
         */
        static addTransform(builder, transformOffset) {
            builder.addFieldStruct(4, transformOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset rangeOffset
         */
        static addRange(builder, rangeOffset) {
            builder.addFieldStruct(5, rangeOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset glyphIdsOffset
         */
        static addGlyphIds(builder, glyphIdsOffset) {
            builder.addFieldOffset(6, glyphIdsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param Array.<number> data
         * @returns flatbuffers.Offset
         */
        static createGlyphIdsVector(builder, data) {
            builder.startVector(4, data.length, 4);
            for (var i = data.length - 1; i >= 0; i--) {
                builder.addInt32(data[i]);
            }
            return builder.endVector();
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startGlyphIdsVector(builder, numElems) {
            builder.startVector(4, numElems, 4);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param flatbuffers.Offset glyphOriginsOffset
         */
        static addGlyphOrigins(builder, glyphOriginsOffset) {
            builder.addFieldOffset(7, glyphOriginsOffset, 0);
        }
        /**
         * @param flatbuffers.Builder builder
         * @param number numElems
         */
        static startGlyphOriginsVector(builder, numElems) {
            builder.startVector(16, numElems, 8);
        }
        /**
         * @param flatbuffers.Builder builder
         * @returns flatbuffers.Offset
         */
        static endTextString(builder) {
            var offset = builder.endObject();
            return offset;
        }
        static createTextString(builder, majorVersion, minorVersion, textOffset, styleOffset, transformOffset, rangeOffset, glyphIdsOffset, glyphOriginsOffset) {
            TextString.startTextString(builder);
            TextString.addMajorVersion(builder, majorVersion);
            TextString.addMinorVersion(builder, minorVersion);
            TextString.addText(builder, textOffset);
            TextString.addStyle(builder, styleOffset);
            TextString.addTransform(builder, transformOffset);
            TextString.addRange(builder, rangeOffset);
            TextString.addGlyphIds(builder, glyphIdsOffset);
            TextString.addGlyphOrigins(builder, glyphOriginsOffset);
            return TextString.endTextString(builder);
        }
    }
    EGFBAccessors.TextString = TextString;
})(EGFBAccessors = exports.EGFBAccessors || (exports.EGFBAccessors = {}));
//# sourceMappingURL=ElementGeometryFB.js.map