export * from "./AmbientOcclusion";
export * from "./AnalysisStyle";
export * from "./BackgroundMapSettings";
export * from "./Base64EncodedString";
export * from "./BriefcaseTypes";
export * from "./Camera";
export * from "./ChangedElements";
export * from "./ChangedEntities";
export * from "./ChangesetProps";
export * from "./ClipStyle";
export * from "./CloudStorage";
export * from "./CloudStorageTileCache";
export * from "./Code";
export * from "./ColorByName";
export * from "./ColorDef";
export * from "./CommonLoggerCategory";
export * from "./ContextRealityModel";
export * from "./DisplayStyleSettings";
export * from "./domains/FunctionalElementProps";
export * from "./domains/GenericElementProps";
export * from "./ECSqlTypes";
export * from "./ElementProps";
export * from "./EmphasizeElementsProps";
export * from "./EntityProps";
export * from "./FeatureGates";
export * from "./FeatureIndex";
export * from "./FeatureSymbology";
export * from "./FeatureTable";
export * from "./Fonts";
export * from "./Frustum";
export * from "./GeoCoordinateServices";
export * from "./geometry/AdditionalTransform";
export * from "./geometry/AreaPattern";
export * from "./geometry/BoundingSphere";
export * from "./geometry/Cartographic";
export * from "./geometry/CoordinateReferenceSystem";
export * from "./geometry/ElementGeometry";
export * from "./geometry/FrustumPlanes";
export * from "./geometry/GeodeticDatum";
export * from "./geometry/GeodeticEllipsoid";
export * from "./geometry/GeometryStream";
export * from "./geometry/ImageGraphic";
export * from "./geometry/LineStyle";
export * from "./geometry/Placement";
export * from "./geometry/Projection";
export * from "./geometry/TextString";
export * from "./GeometryContainment";
export * from "./GeometryParams";
export * from "./GeometrySummary";
export * from "./Gradient";
export * from "./GraphicParams";
export * from "./GroundPlane";
export * from "./HiddenLine";
export * from "./Hilite";
export * from "./HSLColor";
export * from "./HSVColor";
export * from "./Image";
export * from "./IModel";
export * from "./IModelError";
export * from "./IModelVersion";
export * from "./ipc/IpcSocket";
export * from "./ipc/IpcWebSocket";
export * from "./IpcAppProps";
export * from "./LightSettings";
export * from "./LinePixels";
export * from "./MapImagerySettings";
export * from "./MapLayerSettings";
export * from "./MassProperties";
export * from "./MaterialProps";
export * from "./ModelClipGroup";
export * from "./ModelProps";
export * from "./NativeAppProps";
export * from "./OctEncodedNormal";
export * from "./Paging";
export * from "./PlanarClipMask";
export * from "./PlanProjectionSettings";
export * from "./QPoint";
export * from "./Render";
export * from "./RenderMaterial";
export * from "./RenderSchedule";
export * from "./RenderTexture";
export * from "./RgbColor";
export * from "./RpcInterface";
export * from "./RpcManager";
export * from "./SkyBox";
export * from "./Snapping";
export * from "./SolarCalculate";
export * from "./SolarShadows";
export * from "./SpatialClassification";
export * from "./SubCategoryAppearance";
export * from "./SubCategoryOverride";
export * from "./TerrainSettings";
export * from "./TextureMapping";
export * from "./TextureProps";
export * from "./ThematicDisplay";
export * from "./Thumbnail";
export * from "./TileProps";
export * from "./Tween";
export * from "./TxnAction";
export * from "./ViewDetails";
export * from "./ViewFlags";
export * from "./ViewProps";
export * from "./rpc/DevToolsRpcInterface";
export * from "./rpc/IModelReadRpcInterface";
export * from "./rpc/IModelTileRpcInterface";
export * from "./rpc/IModelWriteRpcInterface";
export * from "./ModelGeometryChanges";
export * from "./rpc/SnapshotIModelRpcInterface";
export * from "./rpc/TestRpcManager";
export * from "./rpc/WipRpcInterface";
export * from "./rpc/core/RpcConfiguration";
export * from "./rpc/core/RpcConstants";
export * from "./rpc/core/RpcControl";
export * from "./rpc/core/RpcInvocation";
export * from "./rpc/core/RpcMarshaling";
export * from "./rpc/core/RpcOperation";
export * from "./rpc/core/RpcPendingQueue";
export * from "./rpc/core/RpcProtocol";
export * from "./rpc/core/RpcRegistry";
export * from "./rpc/core/RpcRequest";
export * from "./rpc/core/RpcRequestContext";
export * from "./rpc/core/RpcRoutingToken";
export * from "./rpc/core/RpcPush";
export * from "./rpc/web/BentleyCloudRpcManager";
export * from "./rpc/web/BentleyCloudRpcProtocol";
export * from "./rpc/web/OpenAPI";
export * from "./rpc/web/RpcMultipart";
export * from "./rpc/web/WebAppRpcProtocol";
export * from "./rpc/web/WebAppRpcRequest";
export * from "./tile/B3dmTileIO";
export * from "./tile/CompositeTileIO";
export * from "./tile/ElementGraphics";
export * from "./tile/GltfTileIO";
export * from "./tile/I3dmTileIO";
export * from "./tile/IModelTileIO";
export * from "./tile/PntsTileIO";
export * from "./tile/TileIO";
export * from "./tile/TileMetadata";
export * from "./WhiteOnWhiteReversalSettings";
/** @docs-package-description
 * The imodeljs-common package contains classes for working with iModels that can be used in both [frontend]($docs/learning/frontend/index.md) and [backend]($docs/learning/backend/index.md).
 */
/**
 * @docs-group-description Entities
 * Definitions of the "props" interfaces and types that define the [wire format]($docs/learning/wireformat.md) for communication between the frontend and backend about entities (models, elements, etc) contained in an iModel.
 */
/**
 * @docs-group-description Codes
 * Types for working with [Codes]($docs/bis/intro/codes.md).
 */
/**
 * @docs-group-description Geometry
 * Types for working with geometry.
 */
/**
 * @docs-group-description Serialization
 * Types for serializing geometry
 */
/**
 * @docs-group-description Views
 * Types for defining graphical views of the contents of an iModel.
 */
/**
 * @docs-group-description DisplayStyles
 * Types for describing how the contents of Views should be rendered.
 */
/**
 * @docs-group-description Rendering
 * Types describing geometry, views, and symbology for consumption by a display system.
 */
/**
 * @docs-group-description Symbology
 * Types that define the appearance of geometry.
 */
/**
 * @docs-group-description iModels
 * Types for working with [iModels]($docs/learning/IModels.md) in both the frontend and backend.
 */
/**
 * @docs-group-description RpcInterface
 * Types for working with [RpcInterfaces]($docs/learning/RpcInterface.md).
 */
/**
 * @docs-group-description IpcSocket
 * Types for working with [IpcInterfaces]($docs/learning/IpcInterface.md).
 */
/**
 * @docs-group-description ECSQL
 * Types for working with [ECSQL]($docs/learning/ECSQL.md), [Spatial Queries]($docs/learning/SpatialQueries.md), and [ECSQL Geometry Functions]($docs/learning/GeometrySqlFuncs.md).
 */
/**
 * @docs-group-description Logging
 * Logger categories used by this package.
 */
/**
 * @docs-group-description CloudStorage
 * Types for working with Cloud Storage.
 */
/**
 * @docs-group-description Tween
 * Tweening library adapted from tween.js.
 */
/**
 * @docs-group-description Tile
 * Types for working with 3d tile formats.
 */
/**
 * @docs-group-description Utils
 * Miscellaneous utility classes.
 */
/**
 * @docs-group-description NativeApp
 * [Native applications]($docs/learning/NativeApps.md)
 */
//# sourceMappingURL=imodeljs-common.d.ts.map