/** @packageDocumentation
 * @module RpcInterface
 */
import { IModelConnectionProps, IModelRpcProps, SnapshotOpenOptions } from "../IModel";
import { RpcInterface } from "../RpcInterface";
import { RpcRoutingToken } from "./core/RpcRoutingToken";
/** The RPC interface for working with *snapshot* iModels.
 * This interface is intended for desktop and mobile products. Web products are discouraged from registering this interface.
 * @internal
 */
export declare abstract class SnapshotIModelRpcInterface extends RpcInterface {
    /** Returns the SnapshotIModelRpcInterface client instance for the frontend. */
    static getClient(): SnapshotIModelRpcInterface;
    /** Returns the SnapshotIModelRpcInterface client instance for a custom RPC routing configuration. */
    static getClientForRouting(token: RpcRoutingToken): SnapshotIModelRpcInterface;
    /** The immutable name of the interface. */
    static readonly interfaceName = "SnapshotIModelRpcInterface";
    /** The version of the interface. */
    static interfaceVersion: string;
    openFile(_filePath: string, _opts?: SnapshotOpenOptions): Promise<IModelConnectionProps>;
    openRemote(_key: string, _opts?: SnapshotOpenOptions): Promise<IModelConnectionProps>;
    close(_iModelRpcProps: IModelRpcProps): Promise<boolean>;
}
//# sourceMappingURL=SnapshotIModelRpcInterface.d.ts.map