/** @packageDocumentation
 * @module Tile
 */
import { ByteStream } from "@bentley/bentleyjs-core";
import { TileHeader } from "./TileIO";
/** Header preceding tile content in [composite](https://github.com/AnalyticalGraphicsInc/3d-tiles/tree/master/specification/TileFormats/Composite) format, containing any number of tiles in other standard 3D tile formats.
 * @internal
 */
export declare class CompositeTileHeader extends TileHeader {
    readonly length: number;
    readonly tileCount: number;
    readonly tilePosition: number;
    get isValid(): boolean;
    constructor(stream: ByteStream);
}
//# sourceMappingURL=CompositeTileIO.d.ts.map