"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tile
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompositeTileHeader = void 0;
const TileIO_1 = require("./TileIO");
/** Header preceding tile content in [composite](https://github.com/AnalyticalGraphicsInc/3d-tiles/tree/master/specification/TileFormats/Composite) format, containing any number of tiles in other standard 3D tile formats.
 * @internal
 */
class CompositeTileHeader extends TileIO_1.TileHeader {
    constructor(stream) {
        super(stream);
        this.length = stream.nextUint32;
        this.tileCount = stream.nextUint32;
        this.tilePosition = stream.curPos;
        if (stream.isPastTheEnd)
            this.invalidate();
    }
    get isValid() { return TileIO_1.TileFormat.Cmpt === this.format; }
}
exports.CompositeTileHeader = CompositeTileHeader;
//# sourceMappingURL=CompositeTileIO.js.map