/** @packageDocumentation
 * @module Tile
 */
import { ByteStream } from "@bentley/bentleyjs-core";
import { TileHeader } from "./TileIO";
/** Header preceding tile content in [i3dm](https://github.com/AnalyticalGraphicsInc/3d-tiles/tree/master/specification/TileFormats/Instanced3DModel) format.
 * @internal
 */
export declare class I3dmHeader extends TileHeader {
    readonly length: number;
    readonly featureTableJsonPosition: number;
    readonly featureTableJsonLength: number;
    readonly featureTableBinaryLength: number;
    readonly batchTableJsonLength: number;
    readonly batchTableBinaryLength: number;
    readonly gltfVersion: number;
    readonly batchTableJson: any;
    get isValid(): boolean;
    constructor(stream: ByteStream);
}
//# sourceMappingURL=I3dmTileIO.d.ts.map