/** @packageDocumentation
 * @module Tile
 */
import { ByteStream } from "@bentley/bentleyjs-core";
import { TileHeader } from "./TileIO";
/** Header preceding tile content in [pnts](https://github.com/AnalyticalGraphicsInc/3d-tiles/tree/master/specification/TileFormats/PointCloud) format.
 * @internal
 */
export declare class PntsHeader extends TileHeader {
    readonly length: number;
    readonly featureTableJsonLength: number;
    readonly featureTableBinaryLength: number;
    readonly batchTableJsonLength: number;
    readonly batchTableBinaryLength: number;
    get isValid(): boolean;
    constructor(stream: ByteStream);
}
//# sourceMappingURL=PntsTileIO.d.ts.map