"use strict";
/*---------------------------------------------------------------------------------------------
* Copyright (c) Bentley Systems, Incorporated. All rights reserved.
* See LICENSE.md in the project root for license terms and full copyright notice.
*--------------------------------------------------------------------------------------------*/
/** @packageDocumentation
 * @module Tile
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.PntsHeader = void 0;
const TileIO_1 = require("./TileIO");
/** Header preceding tile content in [pnts](https://github.com/AnalyticalGraphicsInc/3d-tiles/tree/master/specification/TileFormats/PointCloud) format.
 * @internal
 */
class PntsHeader extends TileIO_1.TileHeader {
    constructor(stream) {
        super(stream);
        this.length = stream.nextUint32;
        this.featureTableJsonLength = stream.nextUint32;
        this.featureTableBinaryLength = stream.nextUint32;
        this.batchTableJsonLength = stream.nextUint32;
        this.batchTableBinaryLength = stream.nextUint32;
    }
    get isValid() { return TileIO_1.TileFormat.Pnts === this.format; }
}
exports.PntsHeader = PntsHeader;
//# sourceMappingURL=PntsTileIO.js.map